//opensignal client expert
// see http://onix-trade.net/forum/index.php?showforum=73 for info
extern double Lot=0.1;
//-------------------------------------------------------------------------------------------------------------------
string 	NetPrefix="trade/",	NetSuffix="_trade_60.csv";
string daPath,si,myname;	int aType=-1,tf,a,initok=1,mag=11976; 	double aPrice;
//------==------==------==------==------==------==------==------==------==------==-----
int init(){		tf=Period();	si=Symbol(); myname=WindowExpertName();	initok=0; 
//------==------==------==------==------==------==------==------==------==------==-----
	if(IsTesting()){Alert("Testing mode is unavailable for this version.");	return;}
	if(tf<15){Alert("Please switch timeframe to M15 or greater.");	return;}
	if(tf>60){Alert("Please switch timeframe to H1 or less.");	return;}
	if(!IsDllsAllowed()){Alert("Please enable DLL access for EA in MT4 settings. \n  DLL! (.  )"); return;}	
	if(	StringSubstr(NetPrefix,0,5)=="http:"	)			daPath=NetPrefix;
	else 	daPath="http://protoforma.com/opensignal/signal/"+NetPrefix+LowerCase(si)+NetSuffix;
	Pr("Data path:",daPath);initok=1; 
	sekundomer(2,0);sekundomer(1,0);
	MathSrand(GetTickCount());

}
//------==------==------==------==------==------==------==------==------==------==-----
int start(){	string s=""; double p,hp,x,y; int di, hdi;
//------==------==------==------==------==------==------==------==------==------==-----
	if(!initok){
		Comment(WindowExpertName()+" init failed."); 
		return;
	}
	orderWorx();	
	if ( (!newb_1m()) && sekundomer(2)>0 ) return;	//        x  
	sekundomer(2,300+MathRand()/500); // 300 seconds =  5 minutes
	
	a=netread(daPath,s);	// a = bytes read
	if(a==-4) return; //too frequent requests
	if(a<0){
		Pr("a=",a," retrying net query..");
		Sleep(15000);
		a=netread(daPath,s);
		if(a<0){
			switch(a){
				case -1:Pr("Error. Unable to use InternetAttemptConnect()");	return;
				case -2:Pr("Error. Unable to use InternetOpenA()");			return;
				case -3:Pr("Error. Unable to use InternetOpenUrlA()");			return;
			}
		}
	}
	if( StringSubstr(s,0,3)=="404" ) {	Pr("Error. File "+daPath+" does not exist!");			return;}
	Pr("Bytes read: "+a, "Input: "+daPath,"Output: "+si+"_"+myname);
	di=webGetSignal(s,p);
	hdi=hstGetSignal(hp);
	//Pr("rd LS",hdi, hp,"\nrd WS",di, p);

	if(di<0) {
		di=hdi;
		p=hp;
	}
	if(hdi!=di || hp!=p){
		hstPutSignal(di,p);
		hdi=di;
		hp=p;
	}
	
	aPrice=p;
	aType=di;
}
//------==------==------==------==------==------==------==------==------==------==-----
int deinit(){ Comment(WindowExpertName()+" closed."); }
//-----------------------------------------------------------------------------------------------------------------
double lotsInfo()  {int ob=0,os=0;
//------==------==------==------==------==------==------==------==------==---orders---==-----orders
	double buys=0,sells=0;
	for(int i=0;i<OrdersTotal();i++)	  {
		if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
		if(OrderSymbol()==si && OrderMagicNumber()==mag)		  {
			if(OrderType()==OP_BUY)  {buys+=OrderLots();ob=OrderTicket();}
			if(OrderType()==OP_SELL) {sells+=OrderLots();os=OrderTicket();}
		  }
	  }
	if(buys>0 && sells>0) {OrderCloseBy(ob,os);OrderCloseBy(os,ob);}
	//if(ob*os>0) OrderCloseBy(ob,os);
	return(buys-sells);
}
//------==------==------==------==------==------==------==------==------==---orders---==-----orders
void orderWorx(){	int ti=aType, di=1-ti*2, i,k; 	double p=aPrice, pp, x,  lot;
//------==------==------==------==------==------==------==------==------==---orders---==-----orders
	if (sekundomer(1)>0		) return;
	if (!IsTradeAllowed() 	) return;
	if (IsTradeContextBusy()) return;
	
	x=lotsInfo();
	lot=Lot*di;

	if (ti<0 || ti>1		) return;
	

	if (x*lot>0.00001) {aType=-1; return;}

	//Print(ti," ",p," ",x," ",lot," ");

	if (x==0) {
		if(	ti	==	(p>Bid)	) return;
	}

	lot=NormalizeDouble(MathAbs(lot-x),2);
	RefreshRates();

	if(ti==OP_BUY) pp=Ask; else pp=Bid;

	if (IsTradeContextBusy()) return;
	i=OrderSend(si,ti,lot,pp,0,0,0,"",mag);

	if(i>0)	{	aType=-1; return;}
	
	i=GetLastError();
	//if(i==0){	aType=-1; return;}
	switch(i){ //switch(i){ 	}	switch(i){ 	}
		// -- cancel -- skip 1 bar --
		case 1:
		case 3:
		case 5:
		case 64:// 
		case 65:
		case 131:
		case 133:// 
		case 134:
		case 140:
				aType=-1; 	return;
		// -- skip this tick --
		case 6:
		case 129:
		case 130:
		case 135:
		case 136:
		case 138:
		case 146://  .
				return;
		// -- wait 2 minutes --
		case 4://  .
		case 128:
		case 137:// .
		case 139://    
		case 141:
		case 142:
		case 143:
		case 144:
		case 145:// .    
				sekundomer(1,120);		return;
		// -- wait 15 minutes --
		case 2:		
		case 8:
		case 132:
				sekundomer(1,900);		return;
	}
}
//-----------------------------------------------------------------------------------------------------------------
//------==------==------==------==------==------==------==------==------==---signals--==-----signals
void hstPutSignal(int di, double p){int h=FileOpen(si+"_"+myname, FILE_CSV|FILE_WRITE,',');	FileWrite(h,di,p); 	FileClose(h);}
//------==------==------==------==------==------==------==------==------==---signals--==-----signals
int hstGetSignal(double& p){	int di,h;
//------==------==------==------==------==------==------==------==------==---signals--==-----signals
	h=FileOpen(si+"_"+myname,FILE_CSV|FILE_READ,',');
	if(h<0) return(-1);
	di=FileReadNumber(h);
	p=FileReadNumber(h);
	p=NormalizeDouble(p,Digits);
 	FileClose(h);
 	return(di);
}//------==------==------==------==------==------==------==------==------==--signals--==-----signals
int webGetSignal(string s, double& p){	int i,ii,di=-1; string st;
//------==------==------==------==------==------==------==------==------==---signals--==-----signals
	for(i=StringLen(s)-1-8;i>=0;i--){
		if(StringSubstr(s,i,6)=="market") break;
	}
	if(i<17) return(di);
	if(i<StringLen(s)-15) return(di);
	for(;i>=0;i--){
		st=StringSubstr(s,i,4);
		if(st=="BUY,"){di=OP_BUY;break;}
		else if(st=="ELL,"){di=OP_SELL;break;}
	}
	if(di<0) return(di);
	Pr("\n\nv0.2. Last web signal:",StringSubstr(s,MathMax(i-1,0) ) );
	i=StringFind(s,",",i);	ii=StringFind(s,",",i+1);
	if(ii<0) return(di);
	st=StringSubstr(s,i+1,ii-i-1);	p=NormalizeDouble(StrToDouble(st),Digits);		//if(p>Bid*1.111 || p<Bid*0.9) return(-1);
	return(di);
}/*SELL,1.5881,24/04/2008,2:00,market order0x0A		BUY,1.568,25/04/2008,0:00,market order0x0A	*/
//-------------------------------------------------------------------------------------------------------------------
//------==------==------==------==------==------==------==------==------==------==-----------X-X-X
int sekundomer(int n,int c=-1){static int tz[10];int t=TimeCurrent();if(n<0||n>9)return; if(c>=0) tz[n]=t+c; return(MathMax(0,tz[n]-t)); }
//------==------==------==------==------==------==------==------==------==------==-----------X-X-X
bool newb_1m()  { //     .
//------==------==------==------==------==------==------==------==------==------==-----------X-X-X
	if(Time[0]+60+MathRand()/1000>TimeCurrent()) return(false);	static int knw; if (Time[0]==knw) return(false); knw=Time[0]; return(true); 
}//------==------==------==------==------==------==------==------==------==------==-----------X-X-X
void Pr(string s1, string s2="",string s3="",string s4="",string s5="",string s6="",string s7="",string s8="",string s9=""){
Print(s1+" "+s2+" "+s3+" "+s4+" "+s5+" "+s6+" "+s7+" "+s8+" "+s9);Comment(s1+"\n"+s2+"\n"+s3+"\n"+s4+"\n"+s5+"\n"+s6+"\n"+s7+"\n"+s8+"\n"+s9); }
//------==------==------==------==------==------==------==------==------==------==-----------X-X-X
string LowerCase(string s) {int i,c;for(i=StringLen(s)-1;i>=0;i--){c=StringGetChar(s, i);if(c>64 && c<91) s=StringSetChar(s, i, c+32);}return(s);}
//------==------==------==------==------==------==------==------==------==------==-----------X-X-X
//string UpperCase(string s) {int i,c;for(i=StringLen(s)-1;i>=0;i--){c=StringGetChar(s, i);if(c>96 && c<123) s=StringSetChar(s, i, c-32);}return(s);}
//-------------------------------------------------------------------------------------------------------------------
#import "wininet.dll"
	int InternetAttemptConnect (int x);
	int InternetOpenA(string sAgent, int lAccessType, string sProxyName = "", string sProxyBypass = "", int lFlags = 0);
	int InternetOpenUrlA(int hs, string sUrl,string sHeaders = "", int lHeadersLength = 0,int lFlags = 0, int lContext = 0);
	int InternetReadFile(int hFile, int& sBuffer[], int lNumBytesToRead, int& lNumberOfBytesRead[]);
	int InternetCloseHandle(int hInet);
#import
//------------------------------------------------------------
int netread(string pth, string& s){static int tt; int t=TimeCurrent(),hs,hu,a,b,bu[256],br[1],stl,bl; 	string st;	s="";
//------------------------------------------------------------
	if(t<tt) return(-4);
	a=InternetAttemptConnect(0);
	if(a!=0) return(-1);
	hs=InternetOpenA(myname+" mq", 0, "", "", 		0	);
	if(hs<=0) return(-2);
	tt=t+120;
	hu=InternetOpenUrlA(hs, pth, "", 0, 			0x80000000		, 0);
	if(hu<=0) {	 InternetCloseHandle(hs);return(-3);}
	while(1==1){
		bool bResult = InternetReadFile(hu, bu, 1024, br);	bl=br[0]; 
		if(bl==0)	  break;
		st="";	stl=0;
		for(int i = 0; i < 256; i++){
			st=st+CharToStr(bu[i]&255); 	stl++; if(stl==bl) break;
			st=st+CharToStr(bu[i]>>8&255); 	stl++; if(stl==bl) break;
			st=st+CharToStr(bu[i]>>16&255); stl++; if(stl==bl) break;
			st=st+CharToStr(bu[i]>>24&255); stl++; if(stl==bl) break;
		}
	 	s=s+st;
		Sleep(3);
	}	//InternetCloseHandle(hu);
	InternetCloseHandle(hs);
	return (StringLen(s));
}
//-------------------------------------------------------------------------------------------------------------------

